Attribute VB_Name = "Mod_Lib_Timer"
Option Explicit

' declares:
Private Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long

Const m_intAppTimerMax = 100

' Array of timers
Public aTimers(1 To m_intAppTimerMax) As AppTimer

Private m_intAppTimerCount            As Integer

Function TimerCreate(timer As AppTimer) As Boolean
    
    ' Create the timer
    timer.TimerID = SetTimer(0&, 0&, timer.Interval, AddressOf TimerProc)
    
    If timer.TimerID Then
        
        TimerCreate = True
        
        Dim i As Integer
        
        For i = 1 To m_intAppTimerMax
            
            If aTimers(i) Is Nothing Then
                
                Set aTimers(i) = timer
                
                If (i > m_intAppTimerCount) Then
                    
                    m_intAppTimerCount = i
                
                End If
                
                TimerCreate = True
                
                Exit Function
            
            End If
        
        Next
        
        timer.ErrRaise TooManyTimers
    
    Else
        
        ' TimerCreate = False
        timer.TimerID = 0
        
        timer.Interval = 0
    
    End If


End Function

Public Function TimerDestroy(timer As AppTimer) As Long

    ' Find and remove this timer
    Dim i As Integer, f As Boolean
    
    For i = 1 To m_intAppTimerCount
        
        ' Find timer in array
        If Not aTimers(i) Is Nothing Then
            
            If timer.TimerID = aTimers(i).TimerID Then
                
                f = KillTimer(0, timer.TimerID)
                
                ' Remove timer and set reference to nothing
                Set aTimers(i) = Nothing
                
                TimerDestroy = True
                
                Exit Function
            
            End If
        
        End If
    
    Next

End Function


Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                     ByVal idEvent As Long, ByVal dwTime As Long)
    
    Dim i As Integer
    
    ' Find the timer with this ID
    For i = 1 To m_intAppTimerCount
        
        If Not (aTimers(i) Is Nothing) Then
            
            If idEvent = aTimers(i).TimerID Then
                
                ' Generate the event
                aTimers(i).PulseTimer
                
                Exit Sub
            
            End If
        
        End If
    
    Next

End Sub


Private Function StoreTimer(timer As AppTimer)
    Dim i As Integer
    
    For i = 1 To m_intAppTimerCount
        
        If aTimers(i) Is Nothing Then
            
            Set aTimers(i) = timer
            
            StoreTimer = True
            
            Exit Function
        
        End If
    
    Next

End Function




